<app-loading *ngIf="isLoading"></app-loading>
<div class="content-header">
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" *ngIf="objFunction.create"
             mbButtonText="{{'common.button.add' | translate}}" mbButtonAvailableStyle="PRIMARY"
             (click)="showModalCreate()"></mb-button>
  <mb-button mbButtonSize="MEDIUM" mbButtonText="{{'common.button.update' | translate}}" mbButtonTextColor="#141ED2"
             (click)="showModalUpdate()" *ngIf="objFunction.edit">
  </mb-button>
</div>
<nz-card class="rating-category-card">
  <div class="rating-category-card__row" nz-row>
    <div class="rating-category-card__left" nz-col nzSpan="6">
      <div style="position: relative">
        <mb-select
          [mbDataSelects]="listRating"
          mbKeyLabel="name"
          mbKeyValue="value"
          mbLabelText="{{'goaManagement.ratingCategory.label.rateFor' | translate}}"
          mbPlaceholder=""
          [mbOptionHeightPx]="58"
          [(ngModel)]="param.claType"
        ></mb-select>
      </div>
    </div>
    <div class="rating-category-card__left" nz-col nzSpan="6">
      <div style="position: relative; padding-top: 1.9rem">
        <mb-button
          mbButtonSize="VERY_LARGE"
          mbButtonAvailableStyle="CUSTOM"
          (click)="search()"
          mbButtonText="{{'goaManagement.ratingCategory.button.search' | translate}}"
        ></mb-button>
      </div>
    </div>
  </div>
</nz-card>
<nz-table class="data-table" #basicTable [nzData]="listData" [nzShowPagination]="false" nzTableLayout="fixed"
          nzSize='small'
          [nzScroll]="listData?.length > 8 ? { x: '30rem' } : {}">
  <thead>
    <tr>
      <th nzWidth="10%" class="text-center" scope="col">{{'goaManagement.ratingCategory.table.stt' | translate}}</th>
      <th scope="col">{{'goaManagement.ratingCategory.table.ratingName' | translate}}</th>
      <th scope="col">{{'goaManagement.ratingCategory.table.minPoint' | translate}}</th>
      <th scope="col">{{'goaManagement.ratingCategory.table.maxPoint' | translate}}</th>
      <th scope="col" class="text-center">{{'goaManagement.ratingCategory.table.status' | translate}}</th>
    </tr>
  </thead>
  <tbody>
    <tr *ngFor="let data of basicTable?.data ;let i = index;">
      <td class="text-center">{{ i + 1}}</td>
      <td>{{data.cldName}}</td>
      <td>{{!isDVList ? data.minPoint : ''}}</td>
      <td>{{!isDVList ? data.maxPoint : ''}}</td>
      <td class="text-center">
        <div class="display-center">
          <nz-tag [class]="renderFlagStatus(data.flagStatus).class">
            {{renderFlagStatus(data.flagStatus).text}}
          </nz-tag>
        </div>
      </td>
    </tr>
  </tbody>
</nz-table>
<nz-modal
  nzWidth="{{isUpdateModal ? '60vw' : '40vw'}}"
  [(nzVisible)]="isVisible"
  nzOkText="Lưu"
  nzTitle="{{ isUpdateModal ? ('goaManagement.ratingCategory.label.updateRatingList' | translate) : ('goaManagement.ratingCategory.label.createRatingList' | translate)}}"
  (nzOnCancel)="handleCancel()"
  (nzOnOk)="isUpdateModal ? update() : save() "
>
  <div *nzModalContent>
    <div *ngIf="!isUpdateModal; else elseTplUpdate">
      <div class="rating-category-card__row" nz-row>
        <div class="rating-category-card__left" nz-col nzSpan="12">
          <div style="position: relative">
            <mb-select
              [mbDataSelects]="listRating"
              mbKeyLabel="name"
              mbKeyValue="value"
              mbLabelText="{{'goaManagement.ratingCategory.label.rateFor' | translate}} <span class='label__required'>*</span>"
              mbPlaceholder=""
              [mbType]="isSubmit && !bodyRequest.claType ? 'error' : 'default'"
              [mbShowError]="isSubmit && !bodyRequest.claType"
              [mbErrors]="{required: isSubmit && !bodyRequest.claType}"
              [mbErrorDefs]="[{errorName: 'required', errorDescription: ('goaManagement.ratingCategory.error.required' | translate)}]"
              [mbOptionHeightPx]="58"
              [(ngModel)]="bodyRequest.claType"
              (ngModelChange)="selectItem()"
            ></mb-select>
          </div>
        </div>
        <div class="rating-category-card__left" nz-col nzSpan="12">
          <div style="position: relative">
            <mb-input-text [mbMaxLength]="50" mbPlaceholderText="Nhập thông tin tại đây"
                           mbLabelText="{{'goaManagement.ratingCategory.table.ratingName' | translate}} <span class='label__required'>*</span>"
                           [(ngModel)]="bodyRequest.cldName"
                           [mbType]="isSubmit && !bodyRequest.cldName ? 'error' : 'default'"
                           [mbShowError]="isSubmit && !bodyRequest.cldName"
                           [mbErrors]="{required: isSubmit && !bodyRequest.cldName}"
                           [mbErrorDefs]="[{errorName: 'required', errorDescription: ('goaManagement.ratingCategory.error.required' | translate)}]"
            >

            </mb-input-text>
          </div>
        </div>
      </div>
      <div class="rating-category-card__row" *ngIf="isHide" nz-row>
        <div class="rating-category-card__left" nz-col nzSpan="12">
          <div style="position: relative">
            <mb-input-text mbPlaceholderText="Nhập thông tin tại đây" mbLabelText="{{'goaManagement.ratingCategory.table.minPoint' | translate}} <span class='label__required'>*</span>" [(ngModel)]="bodyRequest.minPoint"
                           mbInputType="number" minNumber="0"
                           [mbType]="isSubmit && listData.length && ((bodyRequest.minPoint >= bodyRequest.maxPoint) || !bodyRequest.minPoint?.toString()) ? 'error' : 'default'"
                           [mbShowError]="isSubmit && listData.length && ((bodyRequest.minPoint >= bodyRequest.maxPoint) || !bodyRequest.minPoint?.toString())"
                           [mbErrors]="{validPoint: isSubmit && listData.length && (bodyRequest.minPoint >= bodyRequest.maxPoint),
                                        required: isSubmit && !bodyRequest.minPoint?.toString()}"
                           [mbErrorDefs]="[{ errorName: 'validPoint', errorDescription: ('goaManagement.ratingCategory.error.invalidMinPoint' | translate)},
                                           { errorName: 'required', errorDescription: ('goaManagement.ratingCategory.error.required' | translate)}]"
                           (mbBlur)="formatPoint($event.target.value, 'min', bodyRequest)"
            >
            </mb-input-text>
          </div>
        </div>
        <div class="rating-category-card__left" nz-col nzSpan="12">
          <div style="position: relative">
            <mb-input-text mbPlaceholderText="Nhập thông tin tại đây" mbLabelText="{{'goaManagement.ratingCategory.table.maxPoint' | translate}}"
                           [mbType]="isSubmit && ((bodyRequest.minPoint >= bodyRequest.maxPoint) && listData.length < 0) ? 'error' : 'default'"
                           [mbShowError]="isSubmit && ((bodyRequest.minPoint >= bodyRequest.maxPoint) && listData.length < 0)"
                           [mbErrors]="{validPoint: isSubmit && (bodyRequest.minPoint >= bodyRequest.maxPoint) && listData.length < 0}"
                           [mbErrorDefs]="[{ errorName: 'validPoint', errorDescription: ('goaManagement.ratingCategory.error.invalidMaxPoint' | translate)}]"
                           mbInputType="number" minNumber="0" (mbBlur)="formatPoint($event.target.value, 'max', bodyRequest)"
                           [ngModel]="convertZeroNumber(bodyRequest.maxPoint)" [mbDisable]="param.claType === 'CN'"></mb-input-text>
          </div>
        </div>
      </div>
      <div class="rating-category-card__row" nz-row>
        <div class="rating-category-card__left" nz-col nzSpan="12">
          <div style="position: relative">
            <mb-select
              [mbDataSelects]="listStatus"
              mbKeyLabel="name"
              mbKeyValue="value"
              mbLabelText="{{'goaManagement.ratingCategory.table.status' | translate}}"
              mbPlaceholder=""
              [mbOptionHeightPx]="58"
              [(ngModel)]="bodyRequest.flagStatus"
              [mbDisable]="true"
            ></mb-select>
          </div>
        </div>
      </div>
    </div>
    <ng-template #elseTplUpdate>
      <nz-table class="data-table ant-table-content" #basicTable [nzData]="listDataModal" [nzShowPagination]="false" nzTableLayout="fixed"
                nzSize='small'
                [nzScroll]="listDataModal?.length > 7 ? { y: '30rem' } : {}">
        <thead>
        <tr>
          <th nzWidth="10%" class="text-center" scope="col">{{'goaManagement.ratingCategory.table.stt' | translate}}</th>
          <th scope="col">{{'goaManagement.ratingCategory.table.ratingName' | translate}}</th>
          <th nzWidth="20%" scope="col">{{'goaManagement.ratingCategory.table.minPoint' | translate}}</th>
          <th nzWidth="20%" scope="col">{{'goaManagement.ratingCategory.table.maxPoint' | translate}}</th>
          <th nzWidth="20%" scope="col">{{'goaManagement.ratingCategory.table.status' | translate}}</th>
        </tr>
        </thead>
        <tbody>
        <tr *ngFor="let data of basicTable?.data ;let i = index;">
          <td class="text-center">{{ i + 1 }}</td>
          <td>
            <mb-input-text [mbShowFlexEnd]="false" [mbMaxLength]="50" [(ngModel)]="data.cldName"
                           (ngModelChange)="checkDuplicate()"
                           [mbType]="isSubmit && data.duplicateName ? 'error' : 'default'"
            >
            </mb-input-text>
          </td>
          <td>
            <div></div>
              <mb-input-text [mbShowFlexEnd]="false" mbInputType="number" minNumber="0" *ngIf="param.claType === 'CN'"
                             (mbBlur)="handlePointValue($event.target.value, 'min', data, i)"
                             [ngModel]="convertZeroNumber(data.minPoint)" (ngModelChange)="processPoint(data, i)"
                             [mbType]="isSubmit && i !== 0 && ((data.maxPoint !== null && data.minPoint >= data.maxPoint) || !data.minPoint?.toString()) ? 'error' : 'default'"
              ></mb-input-text>
          </td>
          <td>
              <mb-input-text [mbShowFlexEnd]="false" *ngIf="param.claType === 'CN'" mbInputType="number" minNumber="0"
                             (mbBlur)="handlePointValue($event.target.value, 'max', data, i)" [mbDisable]="true"
                             [ngModel]="convertZeroNumber(data.maxPoint)" (ngModelChange)="processPoint(data, i)"
                             [mbType]="isSubmit && i !== 0 && ((data.maxPoint !== null && data.minPoint >= data.maxPoint) || !data.minPoint?.toString() || data.invalidMaxValue) ? 'error' : 'default'"
              ></mb-input-text>
          </td>
          <td>
            <mb-select
              [mbDataSelects]="listStatus"
              mbKeyLabel="name"
              mbKeyValue="value"
              [mbLabelText]="null"
              [mbOptionHeightPx]="58"
              [(ngModel)]="data.flagStatus"
              (mbSelect)="calculatePoint($event, i)"
            ></mb-select>
          </td>
        </tr>
        </tbody>
      </nz-table>
    </ng-template>
  </div>
</nz-modal>
